#! /usr/bin/python
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import os
import gtk
import logging

import pygame
import pygame.camera
from pygame.locals import *

from color_name import get_color_name
from gettext import gettext as _
from plugins.plugin import Plugin
from TurtleArt.tapalette import make_palette
from TurtleArt.tapalette import palette_name_to_index
from TurtleArt.tapalette import special_block_colors
from TurtleArt.tapalette import palette_blocks
from TurtleArt.talogo import logoerror
from TurtleArt.tawindow import block_names
from TurtleArt.taconstants import CONSTANTS
from TurtleArt.taprimitive import Primitive, ArgSlot, ConstantArg, or_
from TurtleArt.tatype import TYPE_INT, TYPE_STRING, TYPE_NUMBER

from qrtools import QR

pygame = None
try:
    import pygame
    import pygame.camera
except ImportError:
    print _('Error importing Pygame. This plugin require Pygame 1.9')
    pygame = None

COLOR_PRESENT = ["#00FF00","#008000"]
COLOR_NOTPRESENT = ["#A0A0A0","#808080"]
_logger = logging.getLogger('turtleart-activity qr plugin')


class Qr(Plugin):

    def __init__(self, parent):
        Plugin.__init__(self)
        self.tw = parent
#        self.cam_on = False
#        self.cam_present = False
#        self.cam_init = False
#        self.tamanioc = (320, 240)
#        self.colorc = (255, 255, 255)
#        self.threshold = (25, 25, 25)
#        self.pixels_min = 10
#        self.pixels = 0
#        self.brightness = 128
#        self.color_dist = 9000
#        self.use_average = True
#        self.calibrations = {}
#        self.mode = 'RGB'
#        self.cam = None
#        self.mask = None
#        self.connected = None
#        self.capture = None
#        self.lcamaras = []
        
#####################################################################

    def setup(self):
        palette = make_palette('qr', COLOR_NOTPRESENT, _('qr'), translation=_('qr'))

        palette.add_block('takeqr',
                style='basic-style',
                label=_('Capturar QR'),
                help_string=_('Captura de la camara un codigo QR'),
                prim_name='takeqr')
        self.tw.lc.def_prim('takeqr', 0,
             Primitive(self.prim_takeqr))

	palette.add_block('returnQR',
		style='box-style',
		label=_('Retornar Texto'),
		help_string=_('Leer QR y devolver lectura'),
		value_block=False,
		prim_name='returnqr')
	self.tw.lc.def_prim('returnqr', 0,
	     Primitive(self.prim_returnqr))

#####################################################################

    def prim_takeqr(self):
	# Implementar acciones a tomar aqui
	print "Previo a camara"

	myCode = QR()
	myCode.decode_webcam()
	os.system('streamer -f jpeg -o /usr/share/sugar/activities/TurtleBots.activity/plugins/qr/captura.jpeg')
	myCode = QR(filename=u"/usr/share/sugar/activities/TurtleBots.activity/plugins/qr/captura.jpeg")
	if myCode.decode():
		print myCode.data 
	#os.remove("/usr/share/sugar/activities/TurtleBots.activity/plugins/qr/captura.jpeg")

    def prim_returnqr(self):
	print "Previo a camara"

	myCode = QR()
	myCode.decode_webcam()
	os.system('streamer -f jpeg -o /usr/share/sugar/activities/TurtleBots.activity/plugins/qr/captura.jpeg')
	myCode = QR(filename=u"/usr/share/sugar/activities/TurtleBots.activity/plugins/qr/captura.jpeg")
	if myCode.decode():
		return myCode.data
	return "ERROR"
	#os.remove("/usr/share/sugar/activities/TurtleBots.activity/plugins/qr/captura.jpeg")
